

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Structs.AccelGroupEntry
    ( 

-- * Exported types
    AccelGroupEntry(..)                     ,
    newZeroAccelGroupEntry                  ,
    noAccelGroupEntry                       ,


 -- * Properties
-- ** AccelPathQuark
    accelGroupEntryReadAccelPathQuark       ,


-- ** Closure
    accelGroupEntryReadClosure              ,


-- ** Key
    accelGroupEntryReadKey                  ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype AccelGroupEntry = AccelGroupEntry (ForeignPtr AccelGroupEntry)
-- | Construct a `AccelGroupEntry` struct initialized to zero.
newZeroAccelGroupEntry :: MonadIO m => m AccelGroupEntry
newZeroAccelGroupEntry = liftIO $ callocBytes 32 >>= wrapPtr AccelGroupEntry

noAccelGroupEntry :: Maybe AccelGroupEntry
noAccelGroupEntry = Nothing

accelGroupEntryReadKey :: AccelGroupEntry -> IO AccelKey
accelGroupEntryReadKey s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr AccelKey)
    val' <- (newPtr 12 AccelKey) val
    return val'

accelGroupEntryReadClosure :: AccelGroupEntry -> IO Closure
accelGroupEntryReadClosure s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO (Ptr Closure)
    val' <- (newBoxed Closure) val
    return val'

accelGroupEntryReadAccelPathQuark :: AccelGroupEntry -> IO Word32
accelGroupEntryReadAccelPathQuark s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO Word32
    return val

type family ResolveAccelGroupEntryMethod (t :: Symbol) (o :: *) :: * where
    ResolveAccelGroupEntryMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveAccelGroupEntryMethod t AccelGroupEntry, MethodInfo info AccelGroupEntry p) => IsLabelProxy t (AccelGroupEntry -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveAccelGroupEntryMethod t AccelGroupEntry, MethodInfo info AccelGroupEntry p) => IsLabel t (AccelGroupEntry -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


